/* Copyright (C)  Walter L. Peacock 1984-1988.  All rights reserved */

/* THIS PROGRAM BELONGS TO WALTER L. PEACOCK.  IT IS CONSIDERED A TRADE */
/* SECRET AND IS NOT TO BE DIVULGED OR USED BY PARTIES WHO HAVE NOT    */
/* RECEIVED WRITTEN AUTHORIZATION FROM THE OWNER.                */

/*---------------------------------------------------------------------------- 
 * The btrinit function must be invoked at the beginning of the application 
 * program prior to any calls to CBTREE.   btrinit() reads the CBTREE parameter 
 * file btparms.btr maintained by BTSETUP.EXE and loads the information into
 * the corresponding btcommo structure for the B+tree.  btrinit() initializes 
 * the members of the btcommo structure as follows:
 *
 *   btoptype  is set to GETREC as a default,
 *   btroot    is set to 0L,
 *   btidxlen  is set to the value in BTPARMS.BTR,
 *   btcells    is set to the value in BTPARMS.BTR,
 *   btdtalen  is set to the value in BTPARMS.BTR,
 *   btkeylen  is set to the value in BTPARMS.BTR,
 *   btkey    is set to an allocated memory block of btkeylen + 1 bytes,
 *   btmax    is set to the value in BTPARMS.BTR,
 *   btrecnum  is set to an allocated memory block of btmax + 1 longs,
 *      
 * The character string passed to btrinit() must contain a valid name for a
 * B+tree previously created and recorded using BTSETUP.EXE.
 * A valid name contains 1 to 8 alphanumeric characters.
 *---------------------------------------------------------------------------*/

#include <stdio.h>
#include "cbtree.h"
#include "btfio.h"

#if CI | DC
#else
#include <ctype.h>
#endif

/* 02/04/85 btrinit.c   */

int btrinit(btnme_s, btcp)
char *btnme_s;
BTC *btcp;
{
   extern int   btcinit(), strcmp(), atoi(), close();
   extern long atol();
   extern void  free();
   extern char *calloc();
   extern FILE *fopen();
   unsigned btploc = 0;
   BT_BASE btbase;
   BT_INFO btinfo;
   FILE *btfp;
   int fd, retcode = -1;
   char parmname[9], *fbuff;
   char *nptr, *sptr[7];
   char ilen[6], cell[6], klen[6], dlen[6];
   char szmax[6], *idxname, btrnumb[6];
   register int i, f;

   if ((fbuff = calloc(LINWIDTH, SZCHAR)) == NULL)
      ckerror(- CK_NOMEM, "72");

   if ((idxname = calloc(MAXFNAME + 1, SZCHAR)) == NULL)
      ckerror(- CK_NOMEM, "72");

   *parmname = NUL;   /* tells us whether this entry is in use */
#ifndef NDEBUG
#if 1
printf("\nBTRINIT.C: fopen(\"btparms.btr\",\"r\")...");
#endif
#endif
   if( (btfp = fopen("btparms.btr","r") ) == NULL)
      ckerror(- CK_OPEN, "34");
   while (++btploc < MAXBTREE) {  /* see cbtree.h for MAXBTREE */
      fgets(fbuff, LINWIDTH, btfp);
      f = i = 0;
      nptr = parmname;
      while( ( (*nptr++ = fbuff[f++] ) != DELIMITER) && (i <= SZ_BNAME) )
         ++i;
      *--nptr = NUL;
      if( strcmp(parmname, btnme_s) != 0 )
         continue;				/* note test to continue while loop. */

      /**** we found the matching entry ****/
      sptr[0] = ilen;
      sptr[1] = klen;
      sptr[2] = cell;
      sptr[3] = dlen;
      sptr[4] = szmax;
      sptr[5] = idxname;
      sptr[6] = btrnumb;
      for (i = 0; i < 7; i++){
         while( (*sptr[i]++ = fbuff[f++] ) != DELIMITER)
            ;
         *--sptr[i] = NUL;
      }

      retcode = btcinit(btcp, idxname, parmname, (unsigned) atol(ilen), (unsigned) atol(klen), (unsigned) atol(dlen), (unsigned) atol(szmax));

      break;
   }

   fclose(btfp);
   FREE(fbuff);
   FREE(idxname);
#ifndef NDEBUG
#if 1
printf("\nBTRINIT.C: return(%d)...", retcode);
#endif
#endif
   return(retcode);
}

